{-# LANGUAGE DisambiguateRecordFields #-}
{-# OPTIONS_GHC -Wall -fno-warn-name-shadowing -fno-warn-orphans #-}
module Lam.LamGUI where

import Lam.Lam
import LanguageGUI
import qualified Lam.LamTextRenderer as LamTextRenderer
import Lam.LamVarsInScope 
import qualified Data.Map as Map
import Language

instance LanguageGUI Lam where
  
  render = LamTextRenderer.render

  renderContextInfo = unlines . 
                      map (uncurry (\i s -> s ++ "(" ++ (show i) ++ ")")) .  Map.toList . varsInScope

main :: IO ()
main = initLanguageGUI $ Cursor {
      it = Lam $ (Abs "x" (Unit `Arr` Unit) $ (Var 0) `App` (Abs "y" Unit $ (Var 0) `App` (Var 1))),
      ctx = Stop,
      log = Route Stop Stop
    }
